<?php
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING ^ E_DEPRECATED);
	set_time_limit(60 * 3);
	session_start();


	$clientId = "**";
	$clientSecret = "**";
	$redirectURL = "http://test.dev/youtubeapi/oauthresponse.php";
	

		// if response.txt exists then try to use access_token first , if that fails
		// then use refresh_token first
		$oauthFile = "data/response.txt";
		$f = fopen($oauthFile, "r");
		if ($f) {
			fclose($f);
			
			$contents = file_get_contents($oauthFile);
			$jsonData = unserialize($contents);
			$arrData = json_decode($jsonData, true);
			$accessToken = $arrData["access_token"];
			$refreshToken =  $arrData["refresh_token"];
			$expiresIn = $arrData["expires_in"];
			$tokenType = $arrData["token_type"];

			// check if token has expired by comparing the TTL with file creation time
			// if access token can still be used then use it , else request a  new one using
			// the refresh token

			$filetime = filemtime($oauthFile);
			$expiryTime = $filetime + $expiresIn;
			$currentTime = time();

			if ($expiryTime > $currentTime) {
				$_SESSION["access_token"] = $accessToken;

				// redirect back to calling page
				if ($_SESSION["code_id"]) {
					header("Location:" . $_SESSION["code_id"]);
					exit;
				}	
			} // 	if ($expiryTime > $currentTime) {
		    	
			if ($refreshToken != null && $refreshToken != "") {
				$url = "https://www.googleapis.com/oauth2/v4/token";

				$data = array("client_id"=>$clientId,"client_secret"=>$clientSecret,
						 "refresh_token"=>$refreshToken,
						"grant_type"=>"refresh_token");

				$curl = curl_init();
				curl_setopt_array($curl, array(
							CURLOPT_RETURNTRANSFER => 1,
							CURLOPT_URL => $url,
							CURLOPT_USERAGENT => 'YouTube API Tester',
							CURLOPT_SSL_VERIFYPEER => 1,
							CURLOPT_SSL_VERIFYHOST=> 0,
							CURLOPT_CAINFO => "cert/cacert.pem",
							CURLOPT_CAPATH => "cert/cacert.pem",
							CURLOPT_FOLLOWLOCATION => TRUE,
							CURLOPT_POST=>true,
							CURLOPT_POSTFIELDS=>$postText = http_build_query($data)
							));
				$resp = curl_exec($curl);
				curl_close($curl);


				$arrResp = json_decode($resp, true);
				$accessToken = $arrResp["access_token"];
				$_SESSION["access_token"] = $accessToken;


				if ($accessToken == null) {
					var_dump($resp);
					exit;
				}
	
				// we have a new access token, so write it back to the file
				$arrData["access_token"] = $accessToken;
				$jsonData = json_encode($arrData);
				$f = fopen("data/response.txt", "w");
				if ($f) {
					fwrite($f, serialize($jsonData));
					fclose($f);
				} else
					exit("Error writing  to response.txt");
					
				// redirect back to calling page
				if ($_SESSION["code_id"]) {
					header("Location:" . $_SESSION["code_id"]);
					exit;
				}	

				
			} //  if ($refreshToken != null) {


					
			// if it reaches here it means the refresh_token failed to work so
			// run OAuth again
			
			
		} // 	if ($f) 
		
		// do OAuth because either this is a first time request or the prev oauth data has expired
		$url = "https://accounts.google.com/o/oauth2/v2/auth?client_id=" . 
				$clientId . "&redirect_uri=" . urlencode($redirectURL) . 
				"&response_type=code&scope=" . urlencode("https://www.googleapis.com/auth/youtube") . "+" . 
				urlencode("https://www.googleapis.com/auth/youtube.upload"). "+" .
				urlencode("https://www.googleapis.com/auth/youtubepartner") . "+" .
				urlencode("https://www.googleapis.com/auth/youtube.force-ssl") .

				"&access_type=offline&approval_prompt=force&state=72663";
		$curl = curl_init();
		curl_setopt_array($curl, array(
					CURLOPT_RETURNTRANSFER => 1,
					CURLOPT_URL => $url,
					CURLOPT_USERAGENT => 'YouTube API Tester',
					CURLOPT_SSL_VERIFYPEER => 1,
					CURLOPT_SSL_VERIFYHOST=> 0,
					CURLOPT_CAINFO => "cert/cacert.pem",
					CURLOPT_CAPATH => "cert/cacert.pem",
					CURLOPT_FOLLOWLOCATION => TRUE
					));
		$resp = curl_exec($curl);

		curl_close($curl);
		exit($resp);
			
	
?>
